use ExtUtils::MakeMaker;
WriteMakefile(
	'NAME'=>'Meta',
	'VERSION'=>'0.07',
	'ABSTRACT'=>'Meta class library',
	'AUTHOR'=>'Mark Veltzer <veltzer@cpan.org>',
	'PREREQ_PM'=>{
		'Convert::UU',0.40,
		'XML::Driver::HTML',0.06,
		'SOAP::Lite',0.55,
		'HTTP::Request::Common',1.19,
		'Frontier::Client',undef,
		'WebService::FreeDB',0.4,
		'OpenFrame',3.02,
		'Date::Parse',2.24,
		'DBI',1.32,
		'Cwd',2.04,
		'Pod::Man',1.34,
		'ExtUtils::Installed',0.06,
		'IO::String',1.01,
		'Compress::Bzip2',1.00,
		'GnuPG',0.09,
		'Heap::Elem::NumRev',0.01,
		'Term::ANSIColor',1.05,
		'IO',1.20,
		'Net::FTP',2.65,
		'File::Spec',0.82,
		'MIME::Base64',2.12,
		'SGI::FAM',1.002,
		'IO::Filter::gunzip',0.01,
		'File::Basename',2.6,
		'Getopt::Long',2.32,
		'BerkeleyDB',0.20,
		'Pipeline',2.04,
		'IO::File',1.08,
		'SQL::Statement',1.005,
		'Cache::MemoryCache',undef,
		'Pod::Checker',1.4,
		'Expect',1.15,
		'XML::Writer',0.4,
		'Curses::Widgets::TextField',1.103,
		'OpenFrame::Slot',2.12,
		'Time::Piece',1.07,
		'XML::Simple',1.08,
		'XML::Handler::YAWriter',0.23,
		'Crypt::GPG',1.40,
		'HTML::Form',0.03,
		'HTTP::Response',1.36,
		'Net::SCP',0.06,
		'XML::DOM',1.41,
		'Archive::Tar',0.22,
		'Gtk',0.7008,
		'File::MMagic',1.16,
		'LWP::Simple',1.35,
		'OpenFrame::Response',3.01,
		'Time::Local',undef,
		'File::Spec::Functions',1.1,
		'Graph::Directed',undef,
		'XML::Doctype',0.11,
		'Parse::RecDescent',1.80,
		'Pod::LaTeX',0.54,
		'XML::Generator',0.91,
		'Tk',800.024,
		'OpenFrame::Segment::ContentLoader',undef,
		'Compress::Zlib',1.19,
		'Heap::Elem::Num',0.01,
		'Carp',undef,
		'Image::GD::Thumbnail',0.02,
		'Term::ReadKey',2.21,
		'XML::XQL::DOM',undef,
		'Pod::Html',1.03,
		'DB_File',1.806,
		'Time::localtime',1.01,
		'ExtUtils::MM_Unix',1.34,
		'XML::LibXML',1.53,
		'CGI',2.89,
		'Class::MethodMaker',1.08,
		'base',1.01,
		'XML::ValidWriter',0.37,
		'XML::Handler::BuildDOM',undef,
		'Template',2.08,
		'Curses::Widgets',1.997,
		'Image::Magick',5.49,
		'Image::Size',2.99,
		'Data::Dumper',2.102,
		'File::stat',undef,
		'File::Find',undef,
		'Time::Timezone',101.062101,
		'Pod::Parser',1.13,
		'Date::Manip',5.40,
		'XML::Parser',2.31,
		'File::Path',1.0404,
		'HTTP::Headers',1.43,
		'IO::Handle',1.21,
		'POSIX',1.03,
		'File::Copy',2.03,
		'XML::Checker::Parser',undef,
		'XML::Dumper',0.4,
		'Gtk::Gdk',undef,
		'Gtk::Gdk::ImlibImage',0.7008,
		'Curses::UI',0.71,
		'OpenFrame::Segment::HTTP::Request',undef,
		'XML::Parser::Expat',2.31,
		'Pod::POM',0.15,
		'HTML::TreeBuilder',3.13,
		'HTML::DOMbo',3.08,
		'Gnome',0.7008,
		'Sys::Hostname',1.1,
		'Template::Parser',2.66,
		'OpenFrame::Constants',undef,
		'Data::DumpXML',1.03,
		'HTTP::Daemon',1.25,
		'Curses',1.06,
		'Term::ReadLine',undef,
		'URI',1.22,
		'GraphViz',1.5,
		'XML::Parser::PerlSAX',0.07,
		'IO::Pipe',1.121,
		'Chess::PGN::Parse',0.07,
		'LWP::UserAgent',2.001,
		'HTML::LinkExtor',1.31,
		'XML::Handler::Dtd2Html',0.24,
		'IO::Socket::INET',1.25,
		'XML::XPath',1.12,
		'Module::Info',0.12,
		'XML::DOM::ValParser',undef,
		'XMLRPC::Lite',0.55,
		'SOAP::Transport::TCP',0.55,
		'DirHandle',undef,
		'Pod::Text',2.21,
		'HTTP::Request',1.30,
		'OpenFrame::Server::HTTP',2.12,
		'GraphViz::ISA',0.01,
		'Digest::MD5',2.20,
		'strict',1.01,
		'XML::LibXSLT',1.52,
		'Class::DBI',0.90,
		'Text::Wrap',2001.0929,
		'Mail::Sendmail',0.78,
		'Heap::Fibonacci',0.01,
		'XML::XSLT',0.40,
		'Frontier::Daemon',undef,
		'Sys::Syslog',0.01,
		'GD',2.05,
		'Symbol',1.02,
		'XML::XQL',0.67,
		'Data::ShowTable',undef,
		'ExtUtils::MakeMaker',6.05,
		'HTTP::Status',1.26,
		'MIME::Types',1.004,
	},
	'EXE_FILES'=>[
		'Meta/Comm/Soap/soap_client.pl',
		'Meta/Db/db_drop.pl',
		'Meta/Lang/Xml/xml_stats.pl',
		'Meta/Projects/Md5/md5_produce.pl',
		'Meta/Projects/Md5/md5_finddup.pl',
		'Meta/Projects/Todo/todo_txt2todo.pl',
		'Meta/Aegis/aegis_conf_copy_file_command.pl',
		'Meta/Projects/Contacts/contacts_export.pl',
		'Meta/Demos/demo_gnupg.pl',
		'Meta/Aegis/aegis_conf_development_build_command.pl',
		'Meta/Cook/cook_fpupdate.pl',
		'Meta/Aegis/aegis_conf_diff_command.pl',
		'Meta/Db/db_fix_column.pl',
		'Meta/Baseline/base_tool_symlink_replace.pl',
		'Meta/Projects/Md5/md5_remove.pl',
		'Meta/Baseline/base_tool_log_do.pl',
		'Meta/Tests/import/ansicolor.pl',
		'Meta/Tests/import/mysql.pl',
		'Meta/Projects/Shows/shows_stats.pl',
		'Meta/Projects/Elems/elems_rcd.pl',
		'Meta/Projects/Fortune/fortune_import.pl',
		'Meta/Tests/import/parser.pl',
		'Meta/Projects/Pics/pics_dir_check.pl',
		'Meta/Lang/Perl/perl_check.pl',
		'Meta/Tests/lib/Lang/Perl/deps.pl',
		'Meta/Tests/import/generator.pl',
		'Meta/Tests/lib/Math/ranges.pl',
		'Meta/Demos/demo_uri.pl',
		'Meta/Demos/demo_console.pl',
		'Meta/Tests/import/time_timezone.pl',
		'Meta/Tests/lib/Development/testinfo.pl',
		'Meta/Projects/Movie/movie_loans.pl',
		'Meta/Aegis/aegis_conf_remove_file_command.pl',
		'Meta/Tests/import/sendmail.pl',
		'Meta/Baseline/base_tool_symlink_check.pl',
		'Meta/Projects/Pics/pics_give_dir_names.pl',
		'Meta/Distrib/distrib_distrib.pl',
		'Meta/Projects/Elems/elems_ofhttpd.pl',
		'Meta/Tests/lib/Utils/Parse/text.pl',
		'Meta/Projects/Pics/pics_multi_view.pl',
		'Meta/Tests/lib/Ds/hash.pl',
		'Meta/Tests/regression/import_export.pl',
		'Meta/Projects/Lit/lit_stats.pl',
		'Meta/Demos/demo_info.pl',
		'Meta/Aegis/aegis_conf_project_file_command.pl',
		'Meta/Tests/lib/Utils/output.pl',
		'Meta/Cook/cook_touch.pl',
		'Meta/Tests/import/kde.pl',
		'Meta/Tests/regression/languages.pl',
		'Meta/Lang/Lilypond/lilypond_parse.pl',
		'Meta/Projects/Develop/develop_file.pl',
		'Meta/Tests/lib/Utils/list.pl',
		'Meta/Tests/lib/Utils/File/patho.pl',
		'Meta/Development/development_tt.pl',
		'Meta/Projects/Website/website_httpd.pl',
		'Meta/Demos/demo_syslog.pl',
		'Meta/Projects/Utils/utils_find_holes.pl',
		'Meta/Tests/lib/Lang/Perl/interface.pl',
		'Meta/Projects/Pics/pics_report.pl',
		'Meta/Db/db_console.pl',
		'Meta/Aegis/aegis_conf_integrate_begin_command.pl',
		'Meta/Aegis/aegis_conf_patch_diff_command.pl',
		'Meta/Aegis/aegis_conf_develop_begin_undo_command.pl',
		'Meta/Projects/Email/email_vcard.pl',
		'Meta/Projects/Movie/movie_cgi.pl',
		'Meta/Tests/lib/Utils/File/fs.pl',
		'Meta/Aegis/aegis_conf_merge_command.pl',
		'Meta/Lang/Perl/perl_man.pl',
		'Meta/Lang/Docbook/docbook_check.pl',
		'Meta/Tests/regression/client_server.pl',
		'Meta/Tests/lib/Utils/time.pl',
		'Meta/Aegis/aegis_conf_history_query_command.pl',
		'Meta/Tests/lib/Lang/Perl/Pod/docbook.pl',
		'Meta/Db/db_edit_text.pl',
		'Meta/Tests/regression/dry_run.pl',
		'Meta/Projects/Thumbnail/thumbnail_import.pl',
		'Meta/Baseline/base_aegi_notify.pl',
		'Meta/Projects/Utils/utils_u2d.pl',
		'Meta/Projects/Elems/elems_cgi.pl',
		'Meta/Demos/demo_pgn.pl',
		'Meta/Tests/regression/unit.pl',
		'Meta/Baseline/base_aegi_extra_files.pl',
		'Meta/Tests/import/expect.pl',
		'Meta/Tests/lib/Sql/stats.pl',
		'Meta/Db/db_create.pl',
		'Meta/Aegis/aegis_conf_annotate_diff_command.pl',
		'Meta/Aegis/aegis_conf_batch_test_command.pl',
		'Meta/Aegis/aegis_conf_remove_file_undo_command.pl',
		'Meta/Baseline/base_aegi_base_files.pl',
		'Meta/Cook/cook_rsh.pl',
		'Meta/Projects/Dbman/dbman_import.pl',
		'Meta/Tests/lib/Ds/array.pl',
		'Meta/Projects/Movie/movie_find.pl',
		'Meta/Projects/Pdmt/pdmt.pl',
		'Meta/Projects/Develop/develop_rc.pl',
		'Meta/Comm/Socket/socket_client.pl',
		'Meta/Lang/Xql/xql_shell.pl',
		'Meta/Projects/Dbman/dbman_db.pl',
		'Meta/Projects/Pics/pics_remove_small.pl',
		'Meta/Projects/Fortune/fortune_print.pl',
		'Meta/Tests/lib/Utils/color.pl',
		'Meta/Tests/lib/Utils/Text/unique.pl',
		'Meta/Baseline/base_aegi_remove_files_restore.pl',
		'Meta/Projects/Utils/utils_remove_empty_line.pl',
		'Meta/Demos/demo_scp.pl',
		'Meta/Projects/Lit/lit_loans.pl',
		'Meta/Lang/Xslt/xslt_libxslt_run.pl',
		'Meta/Db/db_drop_sa.pl',
		'Meta/Comm/Frontier/frontier_server.pl',
		'Meta/Fhist/fhist_commit.pl',
		'Meta/Aegis/aegis_conf_new_test_command.pl',
		'Meta/Lang/Perl/perl_profile.pl',
		'Meta/Demos/demo_less.pl',
		'Meta/Lang/Perl/perl_pod_fix.pl',
		'Meta/Lang/Perl/perl_mani.pl',
		'Meta/Projects/Shield/shield_server.pl',
		'Meta/Tests/lib/Utils/utils.pl',
		'Meta/Projects/Pics/pics_info.pl',
		'Meta/Projects/Dbman/dbman_install.pl',
		'Meta/Projects/Dbman/dbman_man.pl',
		'Meta/Fhist/fhist_history.pl',
		'Meta/Demos/demo_lwp.pl',
		'Meta/Comm/Xmlrpc/xmlrpc_client.pl',
		'Meta/Projects/Utils/utils_move_files.pl',
		'Meta/Aegis/aegis_conf_new_file_command.pl',
		'Meta/Tests/lib/Chess/game.pl',
		'Meta/Projects/Evolution/evolution_from.pl',
		'Meta/Tests/lib/Utils/Net/cp.pl',
		'Meta/Db/db_import.pl',
		'Meta/Tests/lib/Tool/gcc.pl',
		'Meta/Projects/Elems/elems_nhttpd.pl',
		'Meta/Projects/Develop/develop_httpd.pl',
		'Meta/Projects/Todo/todo_stats.pl',
		'Meta/Aegis/aegis_conf_test_command.pl',
		'Meta/Ui/lib/Utils/Opts/opts.pl',
		'Meta/Baseline/base_aegi_missing_files.pl',
		'Meta/Demos/demo_bzip2.pl',
		'Meta/Baseline/base_aegi_remove_files_remove.pl',
		'Meta/Projects/Cgi/cgi_misc.pl',
		'Meta/Demos/demo_xql.pl',
		'Meta/Lang/Perl/perl_upload.pl',
		'Meta/Demos/demo_cddb.pl',
		'Meta/Tests/import/showtable.pl',
		'Meta/Development/development_extract.pl',
		'Meta/Ui/lib/Widget/Gtk/xml_tree.pl',
		'Meta/Tests/lib/Tool/aegis.pl',
		'Meta/Projects/Utils/utils_dir_check.pl',
		'Meta/Tests/lib/Utils/File/dir.pl',
		'Meta/Tests/lib/Utils/options.pl',
		'Meta/Projects/Contacts/contacts_ui.pl',
		'Meta/Tests/import/archive.pl',
		'Meta/Aegis/aegis_conf_new_file_undo_command.pl',
		'Meta/Tests/import/time_piece.pl',
		'Meta/Demos/demo_readline.pl',
		'Meta/Lang/Java/java_debug.pl',
		'Meta/Projects/Contacts/contacts_stats.pl',
		'Meta/Tests/lib/Ds/stack.pl',
		'Meta/Lang/Perl/perl_pkglist.pl',
		'Meta/Projects/Pics/pics_single_view.pl',
		'Meta/Comm/Soap/soap_server.pl',
		'Meta/Lang/Xml/xml_dom_print.pl',
		'Meta/Aegis/aegis_conf_develop_begin_command.pl',
		'Meta/Tests/lib/Ds/ohash.pl',
		'Meta/Projects/Utils/utils_give_serial_names.pl',
		'Meta/Projects/Email/email_signature.pl',
		'Meta/Tests/import/oracle.pl',
		'Meta/Tests/lib/Revision/revision.pl',
		'Meta/Tests/import/validwriter.pl',
		'Meta/Projects/Weblog/weblog_curses.pl',
		'Meta/Projects/Mime/mime_import.pl',
		'Meta/Tests/lib/Utils/File/path.pl',
		'Meta/Demos/demo_string.pl',
		'Meta/Projects/Chess/chess_stats.pl',
		'Meta/Baseline/base_aegi_project_files.pl',
		'Meta/Fhist/fhist_ahistory.pl',
		'Meta/Aegis/aegis_conf_new_test_undo_command.pl',
		'Meta/Projects/Develop/develop_find_sym.pl',
		'Meta/Tests/lib/Lang/Perl/perl.pl',
		'Meta/Tests/lib/Utils/File/prop.pl',
		'Meta/Demos/demo_fam.pl',
		'Meta/Aegis/aegis_conf_copy_file_undo_command.pl',
		'Meta/Projects/Chess/chess_merge.pl',
		'Meta/Db/db_edit_def.pl',
		'Meta/Lang/Cpp/cpp_check_cycles.pl',
		'Meta/Aegis/aegis_conf_history_create_command.pl',
		'Meta/Aegis/aegis_conf_development_test_command.pl',
		'Meta/Projects/Mime/mime_import_mt.pl',
		'Meta/Demos/demo_filter.pl',
		'Meta/Projects/Utils/utils_d2u.pl',
		'Meta/Db/db_cgi.pl',
		'Meta/Lang/Java/java_run.pl',
		'Meta/Tests/regression/frontier.pl',
		'Meta/Projects/Website/website_cleanout.pl',
		'Meta/Tests/lib/Utils/File/file.pl',
		'Meta/Projects/Md5/md5_purge.pl',
		'Meta/Tests/lib/Utils/Text/lines.pl',
		'Meta/Lang/Perl/perl_run.pl',
		'Meta/Projects/Music/music_stats.pl',
		'Meta/Tests/import/dumper.pl',
		'Meta/Tests/lib/Ds/enum.pl',
		'Meta/Projects/Utils/utils_wrap.pl',
		'Meta/Baseline/base_tool.pl',
		'Meta/Projects/Elems/elems_httpd.pl',
		'Meta/Tests/lib/Utils/Net/mail.pl',
		'Meta/Baseline/base_aegi_change_files.pl',
		'Meta/Tests/lib/Utils/File/iterator.pl',
		'Meta/Projects/Chess/chess_pgn_stats.pl',
		'Meta/Tests/lib/Utils/pc.pl',
		'Meta/Lang/Perl/perl_graph.pl',
		'Meta/Development/development_apache_dir.pl',
		'Meta/Projects/Evolution/evolution_to.pl',
		'Meta/Tests/lib/Ds/string.pl',
		'Meta/Baseline/base_tool_aspell.pl',
		'Meta/Baseline/base_tool_grep.pl',
		'Meta/Aegis/aegis_conf_change_file_command.pl',
		'Meta/Lang/Html/html_form.pl',
		'Meta/Db/db_sanity.pl',
		'Meta/Db/db_put_file.pl',
		'Meta/Projects/Md5/md5_sum.pl',
		'Meta/Baseline/base_aegi_cleanup.pl',
		'Meta/Baseline/base_aegi_backup.pl',
		'Meta/Demos/demo_gpg.pl',
		'Meta/Projects/Dbman/dbman_fake.pl',
		'Meta/Tests/lib/Development/version.pl',
		'Meta/Tests/import/dirhandle.pl',
		'Meta/Tests/import/date_manip.pl',
		'Meta/Db/db_export.pl',
		'Meta/Tests/import/base64.pl',
		'Meta/Tests/import/dbi.pl',
		'Meta/Aegis/aegis_conf_build_command.pl',
		'Meta/Aegis/aegis_conf_change_file_undo_command.pl',
		'Meta/Db/db_clean.pl',
		'Meta/Tests/import/pod_checker.pl',
		'Meta/Tests/import/ftp.pl',
		'Meta/Db/db_maintain.pl',
		'Meta/Projects/Movie/movie_update.pl',
		'Meta/Projects/Pmail/pmail_import.pl',
		'Meta/Tests/lib/Xml/Parsers/graph.pl',
		'Meta/Tests/lib/Utils/pid.pl',
		'Meta/Projects/Dbman/dbman_cgi.pl',
		'Meta/Demos/demo_ftp.pl',
		'Meta/Aegis/aegis_conf_build_time_adjust_notify_command.pl',
		'Meta/Projects/Utils/utils_sync_dirs.pl',
		'Meta/Lang/Perl/perl_pkgcheck.pl',
		'Meta/Projects/Weblog/weblog_cui.pl',
		'Meta/Tests/lib/Ds/dgraph.pl',
		'Meta/Projects/Utils/utils_stat.pl',
		'Meta/Tests/import/gtk.pl',
		'Meta/Tests/lib/Utils/Net/hostname.pl',
		'Meta/Lang/Xml/xml_lint.pl',
		'Meta/Aegis/aegis_conf_history_put_command.pl',
		'Meta/Projects/Utils/utils_rm.pl',
		'Meta/Demos/demo_gtk.pl',
		'Meta/Comm/Frontier/frontier_client.pl',
		'Meta/Db/db_clean_sa.pl',
		'Meta/Lang/Perl/perl_test.pl',
		'Meta/Tests/lib/Info/certificate.pl',
		'Meta/Tests/import/gnome.pl',
		'Meta/Ui/lib/Widg/Db/connection.pl',
		'Meta/Comm/Socket/socket_server.pl',
		'Meta/Aegis/aegis_conf_nf.pl',
		'Meta/Lang/Perl/perl_check_single.pl',
		'Meta/Projects/Pdmt/pdmt_test.pl',
		'Meta/Projects/Shield/shield_client.pl',
		'Meta/Tests/lib/Db/def.pl',
		'Meta/Tests/lib/Sql/stat.pl',
		'Meta/Projects/Dbman/dbman_find.pl',
		'Meta/Tests/lib/Imdb/get.pl',
		'Meta/Baseline/base_rule_exec.pl',
		'Meta/Demos/demo_iohandle.pl',
		'Meta/Projects/Website/website_upload.pl',
		'Meta/Projects/Chess/chess_ui.pl',
		'Meta/Projects/Movie/movie_stats.pl',
		'Meta/Tests/lib/Tool/fhist.pl',
		'Meta/Tests/lib/Lang/Perl/upload.pl',
		'Meta/Lang/Xml/xml_html_to_xml.pl',
		'Meta/Lang/Perl/perl_debug.pl',
		'Meta/Demos/demo_groff.pl',
		'Meta/Comm/Xmlrpc/xmlrpc_server.pl',
		'Meta/Projects/Pics/pics_import.pl',
		'Meta/Projects/Utils/utils_remove_size.pl',
		'Meta/Tests/import/uu.pl',
		'Meta/Projects/Weblog/weblog_cgi.pl',
		'Meta/Tests/lib/Utils/system.pl',
		'Meta/Tests/import/dateparse.pl',
		'Meta/Projects/Pics/pics_download.pl',
		'Meta/Baseline/base_aegi_source_files.pl',
		'Meta/Projects/Md5/md5_import.pl',
		'Meta/Tests/import/datadumper.pl',
		'Meta/Tests/lib/Utils/debug.pl',
		'Meta/Tests/lib/Utils/File/collect.pl',
		'Meta/Tests/lib/Utils/dos.pl',
		'Meta/Projects/Thumbnail/thumbnail_gtk_ui.pl',
		'Meta/Cook/cook_frsh.pl',
		'Meta/Tests/import/postgres.pl',
		'Meta/Tests/import/installed.pl',
		'Meta/Projects/Movie/movie_import.pl',
		'Meta/Tests/regression/soap.pl',
		'Meta/Tests/import/writer.pl',
		'Meta/Projects/Movie/movie_get.pl',
		'Meta/Tests/regression/xmlrpc.pl',
		'Meta/Projects/Website/website_copy.pl',
		'Meta/Aegis/aegis_conf_history_label_command.pl',
		'Meta/Lang/Xslt/xslt_run.pl',
		'Meta/Demos/demo_tk.pl',
		'Meta/Projects/Pics/pics_ui.pl',
		'Meta/Projects/Utils/utils_purge.pl',
		'Meta/Aegis/aegis_conf_history_get_command.pl',
		'Meta/Baseline/base_aegi_which.pl',
		'Meta/Tests/import/valparser.pl',
	],
);
